<?php
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
 
class GalleryFolder {
    
   private $gDescriptionNode;
    
   private $gFolderName;
    
   private $gRelativeFolderName;
    
   
   
   
    
   public function __construct( DOMNode $inNode, $inGalleryPathName )
   {
      $dom = new DOMDocument;
      $dom->appendChild( $dom->importNode( $inNode, 1 ) );
    
      $xpath = new domxpath( $dom );
      $xpath->registerNamespace( "p", Environment::$configuration[ 'palooseNamespace' ] );  
      
      $this->gFolderName = Utilities::getXPathListStringItem( 0, $xpath, "/p:folder/@src" );
      if ( strlen ( $this->gFolderName ) == 0 ) {
         throw new UserException( 
            "Must have an associated folder name here", 
            PalooseException::SITEMAP_GALLERY_PARSE_ERROR,
            $dom );
      }
      
      $this->gDescriptionNode = Utilities::getXPathListNode( 0, $xpath, "/p:folder/p:description" );
      $requestParameterModule = Environment::$modules[ 'request-param' ];
      $galleryDirectory = $requestParameterModule->get( 'src' );
      
      $this->gRelativeFolderName = Utilities::addTrailingSeparator( $galleryDirectory ) . $this->gFolderName;
      $this->gFolderName = $inGalleryPathName . $this->gFolderName;
   }
   
   
   
    
   public function getDescription()
   {
      return $this->gDescriptionNode;
   }
   
   
   
    
   public function getFolderName()
   {
      return $this->gFolderName;
   }
   
   
   
    
   public function getRelativeFolderName()
   {
      return $this->gRelativeFolderName;
   }
}
?>
