<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/generation/GeneratorPipeElement.php" );
class TidyGenerator extends GeneratorPipeElement implements PipeElementInterface
{
    
   
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
        try {
         parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
        } catch ( UserException $e ) {
           throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
        }
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      
      $expandedString = StringResolver::expandString( $inVariableStack, $this->gSrc );
      $expandedString = StringResolver::expandPseudoProtocols( $expandedString );
      
      
      $documentDOM = new DomDocument();
      
      if ( file_exists( $expandedString ) ) {
      
         $configArray = $this->gComponent->getParameters();
         
         $fileString = file_get_contents( $expandedString );
         
         
         
         
         $reg = "</?[[:alpha:]]+:[[:alnum:]]+[^>]*>";
         $fileString = ereg_replace($reg,"",$fileString);
         
         $reg = "</?\?[^>]*>";
         $fileString = ereg_replace($reg,"",$fileString);
         
         
         
         $reg = "/xmlns:[^=]*\s*=\s*\"[^\"]*\"/";
         $fileString = preg_replace( $reg, "", $fileString );
         
         $reg = "/[\n\r]/";
         $fileString = preg_replace( $reg, " ", $fileString );
         
         
         $reg = "!<style>.*</style>!";
         $fileString = preg_replace( $reg, "", $fileString);
         $reg = "/style[^=]*\s*=\s*[\"\'][^\"\']*[\"\']/";
         $fileString = preg_replace( $reg, "", $fileString);
         
         
         $reg = "#<!--\[if[^>]*>[^!]*!\[endif[^>]*>#";
         $fileString = preg_replace( $reg, "", $fileString );
         $reg = "#<!\[if[^>]*>[^!]*!\[endif[^>]*>#";
         $fileString = preg_replace( $reg, "", $fileString );
         
         
         $tidy = tidy_parse_string( $fileString, $configArray );
         $tidy->cleanRepair();
         
         
         
         
         $fileString = $tidy;
         
         $reg = "/id\s*=\s*[\"\'][^\"\']*[\"\']/";
         $fileString = preg_replace( $reg, "", $fileString );
         
         
         
         
       
          if ( !empty( $tidy->errorBuffer ) ) {
            
         }
         
         if ( !$documentDOM->loadHTML( $fileString ) ) {
            throw new UserException( "Could not load document from repaired file '$expandedString'", PalooseException::SITEMAP_GENERATOR_RUN_ERROR, NULL );
         }
      } else {
           throw new RunException( "File '$expandedString' does not exist", PalooseException::SITEMAP_GENERATOR_RUN_ERROR );
      }
      return $documentDOM;
   }
   
   
   
   public function toString()
   {
      return parent::toString( $this->gGenericType );
   }
}
 
class _TidyGenerator extends Generater {
    
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "TidyGenerator";
   }
}
?>
