<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/resources/Resource.php" );
class Resources {
   
   private $gResources;
   
   private $gDOM;
      
   
   
   
   public function __construct()
   {
      $this->gResources = array();
   }
   
   
   
   public function parse( DOMNode $inNode )
   {
      
      $this->gDOM = new DOMDocument;
      $this->gDOM->appendChild( $this->gDOM->importNode( $inNode, 1 ) );
      
      $xpath = new domxpath( $this->gDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $resource = $xpath->query( "//map:resources/*" );
      
      foreach ( $resource as $node ) { 
         $name = $node->getAttribute( "name" );
         
         if ( array_key_exists( $name, $this->gResources ) ) {
            $dom = new DOMDocument;
            $dom->appendChild( $dom->importNode( $node, 1 ) );
            throw new UserException( "Duplicate resource name '" . $name . "' found", PalooseException::SITEMAP_VIEW_PARSE_ERROR, $dom );
         } else {
            try {
               $resource = new Resource( $name, $node );
               $resource->parse( $node );
               $this->gResources[ $name ] = $resource;
            } catch ( UserException $e ) {
               throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
            }
         }
      }
   }
   
   
   
    
   public function getResource( $inName )
   {
      if ( array_key_exists( $inName, $this->gResources ) ) {
         return $this->gResources[ $inName ];
      } else {
           throw new UserException(
              "Could not find resource '$inName'",
              PalooseException::SITEMAP_CALL_RUN_ERROR,
              $this->gDOM );
      }
   }
   
   
   
    
   public function toString()
   {
      $mess = "";
      if ( $this->gResources != null ) {
         $mess = "  <resources>\n";
         foreach ( $this->gResources as $name => $resource ) {
            $mess .= $resource->toString();
         }
         $mess .= "  </resources>\n";
      }
      return $mess;
   }
}
?>
